<?php
use net\authorize\api\contract\v1 as AnetAPI;
use net\authorize\api\controller as AnetController;

$main_settings = get_option( 'db_main_settings');
$card_data = json_decode( stripslashes( $_POST['card_data'] ), true );



$get_order_meta = get_post_meta( $card_data['db-listing-id'], 'db_order_info', true );
if ( isset($get_order_meta['listing_package']) ) {
	global $wpdb;
	$package_data = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'directory_packages WHERE ID="'.$get_order_meta['listing_package'].'"');
	
	if ( !empty($package_data) ) {
		$package_settings = json_decode( $package_data['0']->package_settings, true );

		$payment_type = (isset($package_settings['payment_type'])?$package_settings['payment_type']:'onetime');
		$single_payment = db_process_single_payment( $main_settings, $card_data );
	}
}

if ( $single_payment != null && $single_payment->getMessages()->getResultCode() == 'Ok' ) {
	if ( $payment_type == 'onetime' ) {
		$tresponse = $single_payment->getTransactionResponse();
		if ( $tresponse != null && $tresponse->getResponseCode() == "1" ) {
			$payment_status = true;
		} else {
			$payment_status = false;
		}
	} else {
		$payment_status = false;

		$subscription_payment = db_process_subscription( $main_settings, $card_data, $package_settings );
		if ( $subscription_payment != null && $subscription_payment->getMessages()->getResultCode() == 'Ok' ) {
			$payment_status = true;
		} else {
			echo '{"save_response": "failed", "message": "'.__('Something went wrong while processing your subscription!', 'directory-builder').'"}';
			die(0);
		}
	}

	if ( $payment_status ) { // Payment succeeded
		$listing_billing = get_post_meta( $card_data['db-listing-id'], 'db_billing_info', true );
		if ( $payment_type == 'onetime' ) {
			$listing_billing['auth-code'] = $tresponse->getAuthCode();
			$listing_billing['trans-id'] = $tresponse->getTransId();
		} else {
			$listing_billing['subscription'] = $subscription_payment->getSubscriptionId();
		}
		update_post_meta( $card_data['db-listing-id'], 'db_billing_info', $listing_billing );


		$payment_status = 'Completed';
		$payment_amount = $card_data['db-package-fee'];
		$listing_id = $card_data['db-listing-id'];

		$order_info = get_post_meta( $listing_id, 'db_order_info', true);

		if ( empty($order_info['payment_history']) ) {
			$order_info['payment_history'] = array(
				date('D, d M Y H:i:s', time()).'==='.$payment_amount.'==='.$payment_status.'===Authorize.Net'
			);
		} else {
			$old_history = $order_info['payment_history'];
			$last_value = explode('===', $old_history[count($old_history)]);
			if ( $last_value['2'] != $payment_status ) {
				$old_history[] = date('D, d M Y H:i:s', time()).'==='.$payment_amount.'==='.$payment_status.'===Authorize.Net';
				$order_info['payment_history'] = $old_history;
			}
		}
		$order_info['payment_status'] = $payment_status;
		if ( $payment_status == 'Completed' ) {
			$order_info['completed_on'] = time();

			global $wpdb;
			$package_data = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'directory_packages WHERE ID="'.$order_info['listing_package'].'"');
			if ( !empty($package_data) ) {
				$package_data = json_decode($package_data['0']->package_settings, true);

				if ( $payment_type != 'onetime' ) {
					if ( $package_settings['payment_cycle'] == 'days' ) {
						$start_value = 1;
					} else if ( $package_settings['payment_cycle'] == 'weeks' ) {
						$start_value = 7;
					} else if ( $package_settings['payment_cycle'] == 'months' ) {
						$start_value = 30;
					} else if ( $package_settings['payment_cycle'] == 'years' ) {
						$start_value = 365;
					}

					$package_data['listing_run_days'] = $start_value*intval($package_settings['payment_interval']);
				}

				if ( isset($order_info['listing_expires']) && is_numeric($order_info['listing_expires']) ) {
					if ( $package_data['listing_run_type'] == 'days' ) {
						$new_expire_date = strtotime('+'.$package_data['listing_run_days'].' days', $order_info['listing_expires']);
						$order_info['listing_expires'] = $new_expire_date;
					}
				} else if ( isset($order_info['listing_expires']) && !is_numeric($order_info['listing_expires']) ) {
					if ( $package_data['listing_run_type'] == 'days' ) {
						$new_expire_date = strtotime('+'.$package_data['listing_run_days'].' days', time());
						$order_info['listing_expires'] = $new_expire_date;
					}
				}
			}
		}

		update_post_meta( $listing_id, 'db_order_info', $order_info );

		$db_post_status = 'publish';
		
		$db_listing = array(
			'ID'           => $listing_id,
			'post_status'  => $db_post_status
		);
		wp_update_post( $db_listing );

		echo '{"save_response": "'.$card_data['db-listing-id'].'", "redirect": "true"}';
	} else {
		echo '{"save_response": "failed", "message": "'.__('Charge Credit Card ERROR: Invalid response', 'directory-builder').'"}';
	}
} else {
	echo '{"save_response": "failed", "message": "'.__('Something went wrong while processing your card!', 'directory-builder').'"}';
}

function db_process_single_payment( $main_settings, $card_data ) {
	$merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
	$merchantAuthentication->setName($main_settings['authorize_id']);
	$merchantAuthentication->setTransactionKey($main_settings['authorize_key']);

	$request = new AnetAPI\CreateTransactionRequest();
	$request->setMerchantAuthentication($merchantAuthentication);

	$creditCard = new AnetAPI\CreditCardType();
	$creditCard->setCardNumber($card_data['x_card_num']);
	$creditCard->setExpirationDate($card_data['x_year']."-".$card_data['x_month']);
	$paymentOne = new AnetAPI\PaymentType();
	$paymentOne->setCreditCard($creditCard);

	// Create a transaction
	$transactionRequestType = new AnetAPI\TransactionRequestType();
	$transactionRequestType->setTransactionType( "authCaptureTransaction"); 
	$transactionRequestType->setAmount($card_data['db-package-fee']);
	$transactionRequestType->setPayment($paymentOne);

	$request = new AnetAPI\CreateTransactionRequest();
	$request->setMerchantAuthentication($merchantAuthentication);
	$request->setTransactionRequest( $transactionRequestType);
	$controller = new AnetController\CreateTransactionController($request);

	if ( $main_settings['payment_mode'] == 'sandbox' ) {
		$response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::SANDBOX);
	} else {
		$response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::PRODUCTION);
	}

	return $response;
}

function db_process_subscription( $main_settings, $card_data, $package_settings ) {
	$merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
	$merchantAuthentication->setName($main_settings['authorize_id']);
	$merchantAuthentication->setTransactionKey($main_settings['authorize_key']);

	$request = new AnetAPI\CreateTransactionRequest();
	$request->setMerchantAuthentication($merchantAuthentication);

	$creditCard = new AnetAPI\CreditCardType();
	$creditCard->setCardNumber($card_data['x_card_num']);
	$creditCard->setExpirationDate($card_data['x_year']."-".$card_data['x_month']);
	$paymentOne = new AnetAPI\PaymentType();
	$paymentOne->setCreditCard($creditCard);

	$subscription_status = false;
	$subscription = new AnetAPI\ARBSubscriptionType();
	$subscription->setName($package_settings['fee_label'].' package subscription');
	$interval = new AnetAPI\PaymentScheduleType\IntervalAType();
	$interval->setLength($package_settings['payment_interval']);
	$interval->setUnit($package_settings['payment_cycle']);

	if ( $package_settings['payment_cycle'] == 'days' ) {
		$start_value = 1;
	} else if ( $package_settings['payment_cycle'] == 'weeks' ) {
		$start_value = 7;
	} else if ( $package_settings['payment_cycle'] == 'months' ) {
		$start_value = 30;
	} else if ( $package_settings['payment_cycle'] == 'years' ) {
		$start_value = 365;
	}

	$paymentSchedule = new AnetAPI\PaymentScheduleType();
	$paymentSchedule->setInterval($interval);
	$paymentSchedule->setStartDate(new DateTime(date('Y-m-d', strtotime(date('Y-m-d', time()) . '+ '.($start_value*intval($package_settings['payment_interval'])).' days'))));
	$paymentSchedule->setTotalOccurrences("24");
	$paymentSchedule->setTrialOccurrences("0");
	$subscription->setPaymentSchedule($paymentSchedule);
	$subscription->setAmount($card_data['db-package-fee']);
	$subscription->setTrialAmount("0.00");
	
	$creditCard = new AnetAPI\CreditCardType();
	$creditCard->setCardNumber($card_data['x_card_num']);
	$creditCard->setExpirationDate($card_data['x_year']."-".$card_data['x_month']);
	$payment = new AnetAPI\PaymentType();
	$payment->setCreditCard($creditCard);
	$subscription->setPayment($payment);
	$order = new AnetAPI\OrderType();
	$order->setInvoiceNumber($card_data['db-listing-id'].time());
	$order->setDescription($package_settings['fee_label'].' package subscription for your listing!'); 
	$subscription->setOrder($order); 
	
	$billing_data = json_decode( stripslashes( $_POST['field_data'] ), true );
	$name_comp = explode(' ', $billing_data['x_full_name']);
	$billTo = new AnetAPI\NameAndAddressType();
	$billTo->setFirstName($name_comp['0']);
	$first_name = $name_comp['0'];
	unset($name_comp['0']);
	$billTo->setLastName((empty($name_comp)?$first_name:implode(' ', $name_comp)));
	$subscription->setBillTo($billTo);
	$request = new AnetAPI\ARBCreateSubscriptionRequest();
	$request->setmerchantAuthentication($merchantAuthentication);
	$request->setRefId('ref' . time());
	$request->setSubscription($subscription);
	$controller = new AnetController\ARBCreateSubscriptionController($request);

	if ( $main_settings['payment_mode'] == 'sandbox' ) {
		$response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::SANDBOX);
	} else {
		$response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::PRODUCTION);
	}

	return $response;
}